# Excel: Read data from excel

| Param Name                                                                                        | Param Desc                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             | Default Value                                     |
| ------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------- |
| fileName                                                                                          | Location & Name of the file                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            | Assume that file is in the Agent Data Folder      |
| sheetName                                                                                         | Excel Sheet from which data must be read                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               | Mandatory Field                                   |
| dataElementName                                                                                   | Name of the Product Element defining the data structure                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                | Valid Prodcut Element with data type QData        |
| dataType                                                                                          | Represent the type of data that you are reading. Select on of the options. \[multiRow, keyValue]                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       | No Default                                        |
| firstRow                                                                                          | Starting row from where the data must be read. For example if the data start from first row, give 1. Remember to match with the row no in excel                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        | 1                                                 |
| firstColumn                                                                                       | Starting column from where the data must be read. For example, if the data start from column A, give 1                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 | 1                                                 |
| firstRowHasColumnHeaders                                                                          | When true smarty will read column names from the first row of the excel. All the column names must be defined a product elements.  When false, it will take column names from the columnNames property                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 | false                                             |
| columnNames                                                                                       | Column name will be mapped to the product elements. Specify column names separated with comma                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          | No default                                        |
| keyColumnName                                                                                     | Specify keyColumnName if data is represented with single field. This is very helpful when doing find on the row on QArray                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              |                                                   |
| adjustColumnData.batch\[Number]:\[columnName] Column procesing is done based on batch no sequence | <p>1) Converting String with delimiter to QStringArray</p><p>Expression to use:</p><p><strong>convertTo</strong>:delimiter.\[Delimiter String/Char]:<strong>dest</strong>.\[Dest Element Name]</p><p>Predefined Delimiters: </p><p><code>comma</code></p><p><code>dot</code></p><p><code>hash</code></p><p><code>hyphen</code></p><p>Custom Delimiter: must be defined in square brackets. Some examples:</p><p><strong>delimiter.\[and]</strong> word and is delimiter</p><p><strong>delimiter.\[break by]</strong> word break by is delimiter</p><p><strong>delimiter.\[']</strong> character single quote is delimiter</p><p></p><p></p><p>2) Moving Another column data as child object</p><p>Expression to use:</p><p><strong>moveAsChild</strong>:keyName.\[Child Column Name]:keyValue.\[Child Column Data]</p> | Optional. Define for columns that need adjustment |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.qatts.com/master-1/smarties/excel-read-data-from-excel.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
